/*
CLIPS Function UserFunctions()
*/
int UserFunctions(void);
int PostWindowsMessage(void);
long SendWindowsMessage(void);

#include <windows.h>
#include "clips.h"
extern HWND HWindow;

int UserFunctions()
{
	DefineFunction("post-windows-message",'b',PostWindowsMessage,
			"PostWindowsMessage");

	DefineFunction("send-windows-message",'l',PTIF SendWindowsMessage,
			"SendWindowsMessage");

}



int PostWindowsMessage(void)
{
	DATA_OBJECT data_wMsg, data_wPar, data_lPar;

	if (ArgCountCheck("post-windows-message",EXACTLY,3) == -1)
		return CLIPS_FALSE;

	if (
	       (ArgTypeCheck("post-windows-message",1,INTEGER,&data_wMsg) == 0)
	    || (ArgTypeCheck("post-windows-message",2,INTEGER,&data_wPar) == 0)
	    || (ArgTypeCheck("post-windows-message",3,INTEGER,&data_lPar) == 0)
	   )
		return CLIPS_FALSE;

	return (
		PostMessage(HWindow,
			    (WORD)DOToInteger(data_wMsg),
			    (WORD)DOToInteger(data_wPar),
			    (DWORD)DOToLong(data_lPar))
	       
	       );
}


long SendWindowsMessage(void)
{
	DATA_OBJECT data_wMsg, data_wPar, data_lPar;

	if (ArgCountCheck("send-windows-message",EXACTLY,3) == -1)
		return CLIPS_FALSE;

	if (
		(ArgTypeCheck("send-windows-message",1,INTEGER,&data_wMsg) == 0)
	     || (ArgTypeCheck("send-windows-message",2,INTEGER,&data_wPar) == 0)
	     || (ArgTypeCheck("send-windows-message",3,INTEGER,&data_lPar) == 0)
	   )
		return CLIPS_FALSE;

	return (
		SendMessage(HWindow,
			    (WORD)DOToInteger(data_wMsg),
			    (WORD)DOToInteger(data_wPar),
			    (DWORD)DOToLong(data_lPar))
		);
}

